clear all
set more off

***** tables in Excel spreadsheet *****
***** example 1
excel2latex,using("tables",excel) saving(table,replace) as(tex) ///
  titlecell(1 1 9) multicolumn(2 2 3 c, 2 5 3 c) notecell(19 1, 20 1) ///
  fonts(footnotesize) makebox(1.1) hline(4) label(summary) notefonts(scriptsize) disp


***** example 2  
/*
// The following command does not work, since an empty column is removed 
// In addition, it writes some but not complete part of the table into table.tex.
// This causes pdflatex compiling not working.
excel2latex,using(tables:tab1,excel) saving(table,append) as(tex) ///
   titlecell(1 1 9) multicolumn(2 2 2 X, 2 5 2 X, 15 2 2 c, 15 5 2 c) ///
   notecell(16 1) fonts(scriptsize) hline(3) label(tab1) notefonts(scriptsize) disp
*/
   
// So we do it in another way
import excel using "tables.xlsx", clear sheet("tab1")

rename (_all)(var1 var2 var3 var4 var5 var6)

cap tostring var4,replace
replace var4="~"

foreach i in 2 3 5 6 {
  destring var`i',gen(tmp`i') force
  tostring tmp`i',replace format(%10.2f) force
  replace var`i'=tmp`i' in 1/14 if tmp`i'~="."
}
drop tmp?

replace var1=subinstr(var1,"levela","level\textsuperscript{a}",1)
replace var1=subinstr(var1,"schoolb","school\textsuperscript{b}",1)
replace var2="\textbf{"+var2+"}" in 2
replace var5="\textbf{"+var5+"}" in 2
replace var1="\cline{2-3} \cline{5-6}" + var1 in 3


foreach i in 2 3 5 6 {
  gen tmp`i'=strpos(var`i',".") in 4/14
  qui sum tmp`i'
  local maxtmp`i'=r(max)
  if `maxtmp`i''>0 {
	 forvalues j=1/`maxtmp`i'' {
	    replace var`i'="~"+var`i' if strpos(var`i',".")<`maxtmp`i'' in 4/14
	 }
  }
}
drop tmp?

local cola=">{\centering\arraybackslash}p{0.3\textwidth}"

excel2latex, saving(table,append) as(tex) makebox(1.1) ///
   titlecell(1 1 9) multicolumn(2 2 2 `cola', 2 5 2 `cola', 15 2 2 c, 15 5 2 c) ///
   notecell(16 1) fonts(scriptsize) hline(3 14) label(tab1) notefonts(scriptsize)

**** example 3
excel2latex,using("tables",excel) saving(table,append) as(tex) ///
   titlecell(1 1 9) multicolumn(2 2 3 c, 2 5 3 c) notecell(19 1, 20 1) ///
   fonts(footnotesize) makebox(1.1) hline(4) label(summary) notefonts(scriptsize)

excel2latex,using(tables:Table 2,excel) saving(table,append) ///
   notecel(49 1, 50 1) fonts(footnotesize) titlec(1 1) hline(4) ///
   multicolumn(2 2 2 c, 2 4 2 c) nonote label(tb:OLS_IV) dropr(45)

***** table in dta format file *****
excel2latex,using("table 1",dta) saving(table,append) as(tex) ///
   titlecell(1 1 9) multicolumn(2 2 3 c, 2 5 3 c) notecell(19 1, 20 1) ///
   fonts(footnotesize) makebox(1.1) hline(4) label(summary) notefonts(scriptsize)

***** table in txt format file *****
excel2latex,using("table 2.txt",txt) saving(table,append) ///
   notecel(49 1, 50 1) fonts(footnotesize) titlec(1 1) hline(4) makebox(1.05) ///
   multicolumn(2 2 2 c, 2 4 2 c) arraystretch(1.1) notefonts(scriptsize)

***** table in csv format file *****
excel2latex,using("table 3",csv) saving(table,append) ///
   fonts(footnotesize) titlec(1 1 10) droprow(19 20) notecell(19 1, 20 1) ///
   multicolumn(2 2 2 c, 2 4 2 c, 5 1 5 l, 11 1 5 l) hline(4 10) notefonts(scriptsize)

